<?php
declare(strict_types=1);

namespace Inti\Provider;

use Inti\Container\Factory\PluginManagerFactory;

/**
 * Class ConfigProvider
 *
 * @package Inti\Provider
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
final class ConfigProvider
{
    public function __invoke(): array
    {
        return [
            'dependencies' => [
                'aliases' => [
                    Service\ProviderManagerInterface::class => Service\ProviderManager::class,
                ],

                'factories' => [
                    Service\ProviderManager::class => PluginManagerFactory::class,
                ],
            ],
        ];
    }
}
