<?php
declare(strict_types=1);

namespace Inti\Provider\Query;

/**
 * Trait QueryTrait
 *
 * @package Inti\Provider\Query
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
trait QueryTrait
{
    protected ?array  $ids    = null;
    protected ?int    $limit  = null;
    protected ?int    $offset = null;
    protected ?string $search = null;
    protected ?array  $slugs  = null;

    public function query(): QueryInterface
    {
        $this->ids = null;
        $this->limit = null;
        $this->offset = null;

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }

    public function id(int $id): QueryInterface
    {
        $this->ids = [$id];

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }

    public function ids(array $ids): QueryInterface
    {
        $this->ids = $ids;

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }

    public function limit(int $limit): QueryInterface
    {
        $this->limit = $limit ?: null;

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }

    public function offset(int $offset): QueryInterface
    {
        $this->offset = $offset ?: null;

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }

    public function search(string $query): QueryInterface
    {
        $this->search = $query ?: null;

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }

    public function slug(string $slug): QueryInterface
    {
        $this->slugs = [$slug];

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }

    public function slugs(array $slugs): QueryInterface
    {
        $this->slugs = $slugs;

        /** @noinspection PhpIncompatibleReturnTypeInspection */
        return $this;
    }
}
