<?php
declare(strict_types=1);

namespace Inti\Provider\Service;

use Inti\Provider\ProviderInterface;
use Inti\Provider\Type\TypeInterface;

/**
 * Interface ProviderManagerInterface
 *
 * @package Inti\Provider\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
interface ProviderManagerInterface
{
    /**
     * @param TypeInterface $type
     * @return bool
     */
    public function canProvide(TypeInterface $type): bool;

    /**
     * @param TypeInterface $type
     * @return ProviderInterface|null
     */
    public function getProvider(TypeInterface $type): ?ProviderInterface;

    /**
     * @param TypeInterface|null $type
     * @return ProviderInterface[]
     */
    public function getProviders(?TypeInterface $type = null): array;

    /**
     * @param ProviderInterface|string $provider
     */
    public function registerProvider($provider): void;

    /**
     * @param ProviderInterface[]|string[] $providers
     */
    public function registerProviders(array $providers): void;
}
