<?php
declare(strict_types=1);

namespace IntiTest\Provider\Mock;

use Inti\Provider\AbstractProvider;
use Inti\Provider\Type\TypeInterface;

/**
 * Class CustomProvider
 *
 * @package IntiTest\Provider\Mock
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-provider
 */
class CustomProvider extends AbstractProvider implements CustomProviderInterface
{
    protected string $type_name = 'custom_type';

    public function __construct(string $type_name)
    {
        $this->type_name = $type_name;
    }

    public function getProvidedType(): TypeInterface
    {
        return CustomType::instance($this->type_name);
    }
}
